// PDN.H

#if !defined ( _PDN_H_ )

#define _PDN_H_

#define GAMEHEADER_RESULT_NUMBER	11

#define PDNLEN	256

#define PDN_EVENT		"Event"
#define PDN_WHITE		"White"
#define PDN_BLACK		"Black"
#define PDN_RESULT		"Result"

#define elements(x) ( (int) ( sizeof x / sizeof x[0] ) )

class CPDN 

{
public:

	char pdn_event[PDNLEN] ;		// PDN Seven-Tag Roster
	char pdn_site[PDNLEN] ;
	char pdn_date[PDNLEN] ;
	char pdn_round[PDNLEN] ;
	char pdn_white[PDNLEN] ;
	char pdn_black[PDNLEN] ;
	char pdn_result[PDNLEN] ;
	int pdn_numresult ;

	bool m_bTurn ;					// FEN, Side to Move
	int m_iBoard[51] ;				// FEN, Position
	int m_iMove ;
	int m_iMovePDN[256][21] ;

	char pdn_setup[PDNLEN] ;		// setup tag
	char pdn_fen[PDNLEN] ;			// fen tag
	char pdn_token[PDNLEN] ;		// current PDN token

	char *pdn_text ;				// memory block allocated for PDN
	char *pdn_ptr ;					// current position in PDN text
	char *pdn_top ;					// start of current PDN game
	char *pdn_last ;				// previous game's position 
	int pdn_size ;					// size of PDN file 
	int pdn_pos ;					// character position within current PDN line

	char* pdn_val[9] ;
	static char *pdn_tag[9] ;
	static const char *str_result[GAMEHEADER_RESULT_NUMBER] ;
	static const int num_result[GAMEHEADER_RESULT_NUMBER]  ;


	CPDN() ;
	~CPDN() ;

	void strip_trailing(char *) ;
	char read_char(void) ;
	void put_char(void) ;
	bool is_white(char) ;
	bool is_symbol(char) ;
	bool Read_Token(void) ;

	bool Read_Header(void) ;
	bool Read_FEN(void) ;
	bool Read_Moves(void) ;
	int	 Read_Game(int, PGAMEHEADER) ;
	bool Read_PDNHeader(void) ;

	void Write_PDNGame(PENGINEDATA) ;

	int Read_PDN(char*, int) ;

} ;

#endif // _PDN_H_